function styleInject(css, ref) {
  if (ref === void 0) ref = {};
  var insertAt = ref.insertAt;
  if (!css || typeof document === 'undefined') {
    return;
  }
  var head = document.head || document.getElementsByTagName('head')[0];
  var style = document.createElement('style');
  style.type = 'text/css';
  if (insertAt === 'top') {
    if (head.firstChild) {
      head.insertBefore(style, head.firstChild);
    } else {
      head.appendChild(style);
    }
  } else {
    head.appendChild(style);
  }
  if (style.styleSheet) {
    style.styleSheet.cssText = css;
  } else {
    style.appendChild(document.createTextNode(css));
  }
}

var css_248z = ".JSXElement.JSXIdentifier{color:#4169e1}.JSXElement.JSXBracket{color:#ff8c00}.JSXElement.JSXText{color:#b8860b}.JSXElement.JSXGlyph{background:cyan;opacity:.25}.JSXClosingFragment.JSXBracket,.JSXOpeningElement.JSXBracket,.JSXOpeningFragment.JSXBracket{color:#ff8c00;font-weight:700}.JSXOpeningElement.JSXIdentifier{color:#4169e1}.JSXClosingElement.JSXBracket{color:#ff8c00;font-weight:lighter}.JSXClosingElement.JSXIdentifier{color:#4169e1;font-weight:lighter}.JSXAttribute.JSXIdentifier{color:#4682b4}.JSXExpressionContainer.JSXBracket,.JSXSpreadAttribute.JSXBracket,.JSXSpreadChild.JSXBracket{color:#ff8c00}";
styleInject(css_248z);

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);

  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }

  return keys;
}

function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }

  return target;
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest();
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArrayLimit(arr, i) {
  var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];

  if (_i == null) return;
  var _arr = [];
  var _n = true;
  var _d = false;

  var _s, _e;

  try {
    for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}

function collectJSXExpressions(ast, traverse) {
  var traverseOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var jsxExpressions = [];
  var enter = function enter(path) {
    if (path.type.toUpperCase().includes("JSX")) {
      jsxExpressions.push(path);
    }
  };
  traverse(ast, _objectSpread2(_objectSpread2({}, traverseOptions), {}, {
    enter: enter
  }));
  return jsxExpressions;
}
var BabelDataExtractor = function () {
  function BabelDataExtractor() {
    _classCallCheck(this, BabelDataExtractor);
  }
  _createClass(BabelDataExtractor, null, [{
    key: "isJSXIdentifier",
    value: function isJSXIdentifier(path) {
      return path && (path.key === 'object' || path.key === 'property' || path.key === 'name' || path.key === 'namespace');
    }
  }, {
    key: "isParentJSXAttribute",
    value: function isParentJSXAttribute(path) {
      return path && path.parentPath && path.parentPath.isJSXAttribute();
    }
  }, {
    key: "getLoc",
    value: function getLoc(path) {
      return path && path.node && path.node.loc;
    }
  }, {
    key: "cloneLoc",
    value: function cloneLoc(path) {
      var loc = BabelDataExtractor.getLoc(path);
      if (!loc) {
        return null;
      }
      return {
        start: _objectSpread2({}, loc.start),
        end: _objectSpread2({}, loc.end)
      };
    }
  }, {
    key: "getCuratedLoc",
    value: function getCuratedLoc(path) {
      var loc = BabelDataExtractor.cloneLoc(path);
      if (!loc) {
        return [null, null, null, null];
      }
      if (path.key === 'object' && path.container) {
        loc.end = _objectSpread2({}, path.container.property.loc.start);
      }
      return loc;
    }
  }, {
    key: "extractJSXOpeningElement",
    value: function extractJSXOpeningElement(path) {
      var openingElement = path.node.openingElement;
      if (!openingElement) {
        return [null, null, null, null];
      }
      var elementName = openingElement.name.name;
      var startLoc = {
        start: _objectSpread2({}, openingElement.loc.start),
        end: _objectSpread2({}, openingElement.name.loc.start)
      };
      var endLoc = {
        start: _objectSpread2({}, openingElement.loc.end),
        end: _objectSpread2({}, openingElement.loc.end)
      };
      endLoc.start.column--;
      if (openingElement.selfClosing) {
        endLoc.start.column--;
      }
      return [openingElement, elementName, startLoc, endLoc];
    }
  }, {
    key: "extractJSXClosingElement",
    value: function extractJSXClosingElement(path) {
      var closingElement = path.node.closingElement;
      if (!closingElement) {
        return [null, null, null, null];
      }
      var elementName = closingElement.name && closingElement.name.name;
      var startLoc = {
        start: _objectSpread2({}, closingElement.loc.start),
        end: _objectSpread2({}, closingElement.name.loc.start)
      };
      var endLoc = {
        start: _objectSpread2({}, closingElement.loc.end),
        end: _objectSpread2({}, closingElement.loc.end)
      };
      endLoc.start.column--;
      return [closingElement, elementName, startLoc, endLoc];
    }
  }, {
    key: "extractJSXExpressionEdges",
    value: function extractJSXExpressionEdges(path) {
      var loc = BabelDataExtractor.getLoc(path);
      if (!loc) {
        return [null, null, null, null];
      }
      var innerNode = null;
      var innerLocKey = path.isJSXSpreadChild() ? 'expression' : path.isJSXSpreadAttribute() ? 'argument' : null;
      var innerLoc = null;
      if (innerLocKey) {
        innerNode = path.node[innerLocKey];
        innerLoc = {
          start: _objectSpread2({}, innerNode.loc.start),
          end: _objectSpread2({}, innerNode.loc.end)
        };
        if (innerNode.extra && innerNode.extra.parenthesized) {
          innerLoc.start.column--;
          innerLoc.end.column++;
        }
      } else {
        innerLoc = {
          start: _objectSpread2({}, loc.start),
          end: _objectSpread2({}, loc.end)
        };
        innerLoc.start.column++;
        innerLoc.end.column--;
      }
      var startEdgeLoc = {
        start: _objectSpread2({}, loc.start),
        end: _objectSpread2({}, innerLoc.start)
      };
      var endEdgeLoc = {
        start: _objectSpread2({}, innerLoc.end),
        end: _objectSpread2({}, loc.end)
      };
      return [innerNode, innerLocKey, startEdgeLoc, endEdgeLoc];
    }
  }]);
  return BabelDataExtractor;
}();

function configureLoc2Range(monaco) {
  var parserType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'babel';
  switch (parserType) {
    case 'babel':
    default:
      return function (loc) {
        var startLineOffset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
        var startColumnOffset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
        var endLineOffset = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
        var endColumnOffset = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
        if (!loc || !loc.start) {
          return new monaco.Range(1, 1, 1, 1);
        }
        return new monaco.Range(startLineOffset + loc.start.line, startColumnOffset + loc.start.column + 1, endLineOffset + loc.end ? loc.end.line : loc.start.line, endColumnOffset + loc.end ? loc.end.column + 1 : loc.start.column + 1);
      };
  }
}
function configureRange2Loc() {
  var parserType = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 'babel';
  switch (parserType) {
    case 'babel':
    default:
      return function (rangeOrPosition) {
        var startLineOffset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
        var startColumnOffset = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;
        var endLineOffset = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;
        var endColumnOffset = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 0;
        var loc = {
          start: {
            line: 0,
            column: 0
          },
          end: {
            line: 0,
            column: 0
          }
        };
        if (!rangeOrPosition) {
          return loc;
        }
        if (rangeOrPosition.lineNumber) {
          loc.start.line = startLineOffset + rangeOrPosition.lineNumber;
          loc.start.column = startColumnOffset + rangeOrPosition.column - 1;
          loc.end.line = endLineOffset + rangeOrPosition.lineNumber;
          loc.end.column = endColumnOffset + rangeOrPosition.column - 1;
        } else {
          loc.start.line = startLineOffset + rangeOrPosition.startLineNumber;
          loc.start.column = startColumnOffset + rangeOrPosition.startColumn - 1;
          loc.end.line = endLineOffset + rangeOrPosition.endLineNumber;
          loc.end.column = endColumnOffset + rangeOrPosition.endColumn - 1;
        }
        return loc;
      };
  }
}
var MonacoEditorManager = _createClass(function MonacoEditorManager(monacoEditor, monaco, loc2Range) {
  var _this = this;
  _classCallCheck(this, MonacoEditorManager);
  _defineProperty(this, "runEditorCommentLineAction", function () {
    return _this.monacoEditor.getAction(MonacoEditorManager.COMMENT_ACTION_ID).run();
  });
  _defineProperty(this, "getLineIndentationColumn", function (lineNumber) {
    return _this.monacoEditor.getModel().getLineFirstNonWhitespaceColumn(lineNumber);
  });
  _defineProperty(this, "getCommentableStartingRange", function (range) {
    var startColumn = _this.getLineIndentationColumn(range.startLineNumber);
    var commentableRange = new _this.monaco.Range(range.startLineNumber, startColumn, range.startLineNumber, startColumn);
    return commentableRange;
  });
  _defineProperty(this, "getCommentContainingStartingRange", function (range) {
    var startColumn = _this.getLineIndentationColumn(range.startLineNumber);
    startColumn = startColumn ? startColumn - 1 : 0;
    var containingRange = new _this.monaco.Range(range.startLineNumber, startColumn, range.startLineNumber, startColumn);
    return containingRange;
  });
  _defineProperty(this, "getSelectionFirstLineText", function () {
    var model = _this.monacoEditor.getModel();
    var _this$monacoEditor$ge = _this.monacoEditor.getSelection(),
        startLineNumber = _this$monacoEditor$ge.startLineNumber;
    var jsCommentRange = new _this.monaco.Range(startLineNumber, _this.getLineIndentationColumn(startLineNumber), startLineNumber, model.getLineMaxColumn(startLineNumber));
    return model.getValueInRange(jsCommentRange);
  });
  this.monacoEditor = monacoEditor;
  this.monaco = monaco;
  this.loc2Range = loc2Range;
}
);
_defineProperty(MonacoEditorManager, "COMMENT_ACTION_ID", "editor.action.commentLine");

var _HIGHLIGHT_MODE;
function prepareOptions(path) {
  var jsxTypeOptions = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var highlighterOptions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  return highlighterOptions.iShowHover ? _objectSpread2(_objectSpread2({}, jsxTypeOptions), {
    hoverMessage: "(".concat(path.type, ")")
  }) : jsxTypeOptions;
}
var HIGHLIGHT_TYPE = {
  ELEMENT: 'ELEMENT',
  ALL: 'ALL',
  IDENTIFIER: 'IDENTIFIER',
  EDGE: 'EDGE',
  STYLE: 'STYLE'
};
var HIGHLIGHT_MODE = (_HIGHLIGHT_MODE = {}, _defineProperty(_HIGHLIGHT_MODE, HIGHLIGHT_TYPE.ELEMENT, function (path, jsxTypeOptions, highlighterOptions) {
  var _BabelDataExtractor$e = BabelDataExtractor.extractJSXOpeningElement(path),
      _BabelDataExtractor$e2 = _slicedToArray(_BabelDataExtractor$e, 4),
      openingElement = _BabelDataExtractor$e2[0],
      elementName = _BabelDataExtractor$e2[1],
      startLoc = _BabelDataExtractor$e2[2],
      endLoc = _BabelDataExtractor$e2[3];
  var result = [];
  if (openingElement) {
    result.push([startLoc, highlighterOptions.isUseSeparateElementStyles ? JSXTypes.JSXBracket.openingElementOptions : JSXTypes.JSXBracket.options]);
    result.push([endLoc, highlighterOptions.isUseSeparateElementStyles ? JSXTypes.JSXBracket.openingElementOptions : JSXTypes.JSXBracket.options]);
  }
  var _BabelDataExtractor$e3 = BabelDataExtractor.extractJSXClosingElement(path),
      _BabelDataExtractor$e4 = _slicedToArray(_BabelDataExtractor$e3, 4),
      closingElement = _BabelDataExtractor$e4[0],
      closingElementStartLoc = _BabelDataExtractor$e4[2],
      closingElementEndLoc = _BabelDataExtractor$e4[3];
  if (closingElement) {
    result.push([closingElementStartLoc, highlighterOptions.isUseSeparateElementStyles ? JSXTypes.JSXBracket.closingElementOptions : JSXTypes.JSXBracket.options]);
    result.push([closingElementEndLoc, highlighterOptions.isUseSeparateElementStyles ? JSXTypes.JSXBracket.closingElementOptions : JSXTypes.JSXBracket.options]);
  }
  var loc = BabelDataExtractor.getLoc(path);
  highlighterOptions.isHighlightGlyph && result.push([loc, JSXTypes.JSXElement.options(elementName)]);
  return result;
}), _defineProperty(_HIGHLIGHT_MODE, HIGHLIGHT_TYPE.ALL, function (path, jsxTypeOptions, highlighterOptions) {
  var curatedLoc = BabelDataExtractor.getCuratedLoc(path);
  var result = [];
  curatedLoc && result.push([curatedLoc, prepareOptions(path, jsxTypeOptions, highlighterOptions)]);
  return result;
}), _defineProperty(_HIGHLIGHT_MODE, HIGHLIGHT_TYPE.IDENTIFIER, function (path, jsxTypeOptions, highlighterOptions) {
  if (!BabelDataExtractor.isJSXIdentifier(path)) {
    return [];
  }
  return HIGHLIGHT_MODE[HIGHLIGHT_TYPE.ALL](path, BabelDataExtractor.isParentJSXAttribute(path) ? JSXTypes.JSXAttribute.options : jsxTypeOptions, highlighterOptions);
}), _defineProperty(_HIGHLIGHT_MODE, HIGHLIGHT_TYPE.EDGE, function (path, jsxTypeOptions, highlighterOptions) {
  var options = prepareOptions(path, jsxTypeOptions, highlighterOptions);
  var _BabelDataExtractor$e5 = BabelDataExtractor.extractJSXExpressionEdges(path),
      _BabelDataExtractor$e6 = _slicedToArray(_BabelDataExtractor$e5, 4),
      startEdgeLoc = _BabelDataExtractor$e6[2],
      endEdgeLoc = _BabelDataExtractor$e6[3];
  var result = [];
  result.push([startEdgeLoc, options]);
  result.push([endEdgeLoc, options]);
  return result;
}), _defineProperty(_HIGHLIGHT_MODE, HIGHLIGHT_TYPE.STYLE, function () {
  return [];
}), _HIGHLIGHT_MODE);
var JSXTypes = {
  JSXIdentifier: {
    highlightScope: HIGHLIGHT_TYPE.IDENTIFIER,
    options: {
      inlineClassName: 'JSXElement.JSXIdentifier'
    }
  },
  JSXOpeningFragment: {
    highlightScope: HIGHLIGHT_TYPE.ALL,
    options: {
      inlineClassName: 'JSXOpeningFragment.JSXBracket'
    }
  },
  JSXClosingFragment: {
    highlightScope: HIGHLIGHT_TYPE.ALL,
    options: {
      inlineClassName: 'JSXClosingFragment.JSXBracket'
    }
  },
  JSXText: {
    highlightScope: HIGHLIGHT_TYPE.ALL,
    options: {
      inlineClassName: 'JSXElement.JSXText'
    }
  },
  JSXExpressionContainer: {
    highlightScope: HIGHLIGHT_TYPE.EDGE,
    options: {
      inlineClassName: 'JSXExpressionContainer.JSXBracket'
    }
  },
  JSXSpreadChild: {
    highlightScope: HIGHLIGHT_TYPE.EDGE,
    options: {
      inlineClassName: 'JSXSpreadChild.JSXBracket'
    }
  },
  JSXSpreadAttribute: {
    highlightScope: HIGHLIGHT_TYPE.EDGE,
    options: {
      inlineClassName: 'JSXSpreadAttribute.JSXBracket'
    }
  },
  JSXElement: {
    highlightScope: HIGHLIGHT_TYPE.ELEMENT,
    options: function options(elementName) {
      return {
        glyphMarginClassName: 'JSXElement.JSXGlyph',
        glyphMarginHoverMessage: "JSX Element".concat(elementName ? ': ' + elementName : '')
      };
    }
  },
  JSXBracket: {
    highlightScope: HIGHLIGHT_TYPE.STYLE,
    options: {
      inlineClassName: 'JSXElement.JSXBracket'
    },
    openingElementOptions: {
      inlineClassName: 'JSXOpeningElement.JSXBracket'
    },
    closingElementOptions: {
      inlineClassName: 'JSXClosingElement.JSXBracket'
    }
  },
  JSXOpeningElement: {
    highlightScope: HIGHLIGHT_TYPE.STYLE,
    options: {
      inlineClassName: 'JSXOpeningElement.JSXIdentifier'
    }
  },
  JSXClosingElement: {
    highlightScope: HIGHLIGHT_TYPE.STYLE,
    options: {
      inlineClassName: 'JSXClosingElement.JSXIdentifier'
    }
  },
  JSXAttribute: {
    highlightScope: HIGHLIGHT_TYPE.STYLE,
    options: {
      inlineClassName: 'JSXAttribute.JSXIdentifier'
    }
  }
};
var DecoratorMapper = _createClass(function DecoratorMapper(monacoEditor, loc2Range) {
  var _JSXTypes = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : JSXTypes;
  _classCallCheck(this, DecoratorMapper);
  var decorators = [];
  var jsxDecoratorIds = [];
  var addDecorator = function addDecorator(_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        loc = _ref2[0],
        options = _ref2[1];
    return decorators.push({
      range: loc2Range(loc),
      options: options
    });
  };
  var deltaDecorations = function deltaDecorations() {
    jsxDecoratorIds = monacoEditor.deltaDecorations(jsxDecoratorIds || [], decorators);
    decorators = [];
    return jsxDecoratorIds;
  };
  this.deltaJSXDecorations = function (jsxExpressions, options) {
    var _loop = function _loop(jsxType) {
      jsxExpressions.filter(function (path) {
        return path.type === jsxType;
      }).forEach(function (path) {
        return HIGHLIGHT_MODE[_JSXTypes[jsxType].highlightScope](path, _JSXTypes[jsxType].options, options).forEach(function (entry) {
          return addDecorator(entry);
        });
      });
    };
    for (var jsxType in _JSXTypes) {
      _loop(jsxType);
    }
    return deltaDecorations();
  };
  this.reset = function () {
    decorators = [];
    deltaDecorations();
  };
  this.reset();
});

var JSXCommentContexts = {
  JS: 'JS',
  JSX: 'JSX'
};
function getJSXContext(jsxExpressions, commentableRange, commentContainingRange, loc2Range) {
  if (!(jsxExpressions && commentableRange && commentContainingRange && loc2Range)) {
    return JSXCommentContexts.JS;
  }
  var minRange = null;
  var minCommentableRange = null;
  var path = null;
  var commentablePath = null;
  jsxExpressions.forEach(function (p) {
    var jsxRange = loc2Range(p.node.loc);
    if ((p.key === 'name' || p.key === 'property') && p.isJSXIdentifier() && jsxRange.intersectRanges(commentableRange)) {
      if (!minCommentableRange || minCommentableRange.containsRange(jsxRange)) {
        minCommentableRange = jsxRange;
        commentablePath = p;
      }
    }
    if (jsxRange.intersectRanges(commentContainingRange)) {
      if (!minRange || minRange.containsRange(jsxRange)) {
        minRange = jsxRange;
        path = p;
      }
    }
  });
  if (!path || path.isJSXExpressionContainer() || commentablePath) {
    return JSXCommentContexts.JS;
  } else {
    return JSXCommentContexts.JSX;
  }
}
var Commenter = _createClass(function Commenter(monacoEditorManager, parseJSXExpressionsPromise) {
  var _this = this;
  _classCallCheck(this, Commenter);
  var _editorCommandId = null;
  this.getEditorCommandId = function () {
    return _editorCommandId;
  };
  var _isJSXCommentCommandActive = false;
  this.isJSXCommentCommandActive = function () {
    return _isJSXCommentCommandActive;
  };
  var editorCommandOnDispose = function editorCommandOnDispose() {
    _isJSXCommentCommandActive = false;
  };
  this.runJsxCommentAction = function (selection, commentContext) {
    var monacoEditor = monacoEditorManager.monacoEditor,
        monaco = monacoEditorManager.monaco,
        runEditorCommentLineAction = monacoEditorManager.runEditorCommentLineAction,
        getSelectionFirstLineText = monacoEditorManager.getSelectionFirstLineText;
    var jsCommentText = getSelectionFirstLineText();
    if (jsCommentText.match(/^\s*\/[/*]/)) {
      runEditorCommentLineAction(monacoEditor);
      return;
    }
    var model = monacoEditor.getModel();
    var isUnCommentAction = true;
    var commentsData = [];
    for (var i = selection.startLineNumber; i <= selection.endLineNumber; i++) {
      var commentRange = new monaco.Range(i, model.getLineFirstNonWhitespaceColumn(i), i, model.getLineMaxColumn(i));
      var commentText = model.getValueInRange(commentRange);
      commentsData.push({
        commentRange: commentRange,
        commentText: commentText
      });
      isUnCommentAction = isUnCommentAction && !!commentText.match(/{\/\*/);
    }
    if (commentContext !== JSXCommentContexts.JSX && !isUnCommentAction) {
      runEditorCommentLineAction(monacoEditor);
      return;
    }
    var editOperations = [];
    var commentsDataIndex = 0;
    for (var _i = selection.startLineNumber; _i <= selection.endLineNumber; _i++) {
      var _commentsData$comment = commentsData[commentsDataIndex++],
          _commentText = _commentsData$comment.commentText,
          _commentRange = _commentsData$comment.commentRange;
      if (isUnCommentAction) {
        _commentText = _commentText.replace(/{\/\*/, '');
        _commentText = _commentText.replace(/\*\/}/, '');
      } else {
        _commentText = "{/*".concat(_commentText, "*/}");
      }
      editOperations.push({
        identifier: {
          major: 1,
          minor: 1
        },
        range: _commentRange,
        text: _commentText,
        forceMoveMarkers: true
      });
    }
    editOperations.length && monacoEditor.executeEdits(_editorCommandId, editOperations);
  };
  this.addJSXCommentCommand = function () {
    var monacoEditor = monacoEditorManager.monacoEditor,
        monaco = monacoEditorManager.monaco,
        loc2Range = monacoEditorManager.loc2Range,
        runEditorCommentLineAction = monacoEditorManager.runEditorCommentLineAction,
        getCommentableStartingRange = monacoEditorManager.getCommentableStartingRange,
        getCommentContainingStartingRange = monacoEditorManager.getCommentContainingStartingRange;
    if (_editorCommandId) {
      _isJSXCommentCommandActive = true;
      return editorCommandOnDispose;
    }
    _editorCommandId = monacoEditor.addCommand(monaco.KeyMod.CtrlCmd | monaco.KeyCode.US_SLASH, function () {
      if (!_isJSXCommentCommandActive) {
        return runEditorCommentLineAction(monacoEditor);
      }
      parseJSXExpressionsPromise().then(function (jsxExpressions) {
        var selection = monacoEditor.getSelection();
        var commentContext = getJSXContext(jsxExpressions, getCommentableStartingRange(selection), getCommentContainingStartingRange(selection), loc2Range);
        _this.runJsxCommentAction(selection, commentContext);
      });
    });
    _isJSXCommentCommandActive = true;
    monacoEditor.onDidDispose(editorCommandOnDispose);
    return editorCommandOnDispose;
  };
});

var defaultOptions = {
  parser: 'babel',
  isHighlightGlyph: false,
  iShowHover: false,
  isUseSeparateElementStyles: false,
  monacoEditorManager: null,
  decoratorMapper: null,
  jsxCommenter: null
};
var makeGetAstPromise = function makeGetAstPromise(parse, monacoEditor) {
  return function () {
    return new Promise(function (resolve, reject) {
      try {
        resolve(parse(monacoEditor.getValue())
        );
      } catch (e) {
        reject(e);
      }
    });
  };
};
var makeParseJSXExpressionsPromise = function makeParseJSXExpressionsPromise(traverse, getAstPromise) {
  var _collectJSXExpressions = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : collectJSXExpressions;
  return function () {
    return new Promise(function (resolve, reject) {
      getAstPromise().then(function (ast) {
        try {
          resolve(_collectJSXExpressions(ast, traverse));
        } catch (e) {
          reject(e);
        }
      });
    });
  };
};
var makeJSXCommenterBundle = function makeJSXCommenterBundle(monaco, parse, traverse, monacoEditor) {
  var options = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  var parserType = options.parserType,
      jsxCommenter = options.jsxCommenter,
      monacoEditorManager = options.monacoEditorManager;
  var range2Loc = configureRange2Loc(parserType);
  var loc2Range = configureLoc2Range(monaco, parserType);
  var getAstPromise = makeGetAstPromise(parse, monacoEditor);
  var parseJSXExpressionsPromise = makeParseJSXExpressionsPromise(traverse, getAstPromise);
  var _monacoEditorManager = monacoEditorManager || new MonacoEditorManager(monacoEditor, monaco, loc2Range);
  var _jsxCommenter = jsxCommenter || new Commenter(_monacoEditorManager, parseJSXExpressionsPromise);
  return [_jsxCommenter, _monacoEditorManager, parseJSXExpressionsPromise, getAstPromise, loc2Range, range2Loc];
};
var MonacoJSXHighlighter = _createClass(function MonacoJSXHighlighter(monaco, parse, traverse, monacoEditor) {
  var _this = this;
  var options = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : {};
  _classCallCheck(this, MonacoJSXHighlighter);
  this.options = _objectSpread2(_objectSpread2({}, defaultOptions), options);
  var decoratorMapper = this.options.decoratorMapper;
  var _makeJSXCommenterBund = makeJSXCommenterBundle(monaco, parse, traverse, monacoEditor, this.options),
      _makeJSXCommenterBund2 = _slicedToArray(_makeJSXCommenterBund, 6),
      _jsxCommenter = _makeJSXCommenterBund2[0],
      _monacoEditorManager = _makeJSXCommenterBund2[1],
      parseJSXExpressionsPromise = _makeJSXCommenterBund2[2],
      getAstPromise = _makeJSXCommenterBund2[3],
      loc2Range = _makeJSXCommenterBund2[4],
      range2Loc = _makeJSXCommenterBund2[5];
  this.jsxCommenter = _jsxCommenter;
  this.monacoEditorManager = _monacoEditorManager;
  this.parseJSXExpressionsPromise = parseJSXExpressionsPromise;
  this.getAstPromise = getAstPromise;
  this.loc2Range = loc2Range;
  this.range2Loc = range2Loc;
  this.addJSXCommentCommand = this.jsxCommenter.addJSXCommentCommand;
  this.decoratorMapper = decoratorMapper || new DecoratorMapper(monacoEditor, this.loc2Range);
  this.decoratorMapperReset = function () {
    decoratorMapper.reset();
  };
  this.highlight = function (ast) {
    return new Promise(function (resolve, reject) {
      var decoratorMapper = _this.decoratorMapper,
          options = _this.options;
      var result = {
        decoratorMapper: decoratorMapper,
        options: options,
        ast: ast,
        jsxExpressions: []
      };
      if (!ast) {
        resolve(result);
      }
      try {
        var jsxExpressions = collectJSXExpressions(ast, traverse);
        decoratorMapper.deltaJSXDecorations(jsxExpressions, options);
        result.jsxExpressions = jsxExpressions;
        resolve(result);
      } catch (e) {
        reject(e);
      }
    });
  };
  this.highlightCode = function () {
    var afterHighlight = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function (ast) {
      return ast;
    };
    var onHighlightError = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (error) {
      return error;
    };
    var getAstPromise = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : _this.getAstPromise;
    var onGetAstErrors = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : function (error) {
      return error;
    };
    return getAstPromise().then(function (ast) {
      _this.highlight(ast).then(afterHighlight)["catch"](onHighlightError);
    })["catch"](onGetAstErrors);
  };
  var _isHighlightBoundToModelContentChanges = false;
  this.isHighlightBoundToModelContentChanges = function () {
    return _isHighlightBoundToModelContentChanges;
  };
  this.highlightOnDidChangeModelContent = function () {
    var debounceTime = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : 100;
    var afterHighlight = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (ast) {
      return ast;
    };
    var onHighlightError = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function (error) {
      return error;
    };
    var getAstPromise = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : _this.getAstPromise;
    var onParseAstError = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : function (error) {
      return error;
    };
    var highlightCallback = function highlightCallback() {
      return _this.highlightCode(afterHighlight, onHighlightError, getAstPromise, onParseAstError);
    };
    highlightCallback();
    var tid = null;
    var highlighterDisposer = {
      onDidChangeModelContentDisposer: monacoEditor.onDidChangeModelContent(function () {
        clearTimeout(tid);
        tid = setTimeout(highlightCallback, debounceTime);
      }),
      onDidChangeModelDisposer: monacoEditor.onDidChangeModel(function () {
        highlightCallback();
      })
    };
    highlighterDisposer.dispose = function () {
      highlighterDisposer.onDidChangeModelContentDisposer.dispose();
      highlighterDisposer.onDidChangeModelDisposer.dispose();
    };
    _isHighlightBoundToModelContentChanges = true;
    var onDispose = function onDispose() {
      _this.decoratorMapper.reset();
      if (!_isHighlightBoundToModelContentChanges) {
        return;
      }
      _isHighlightBoundToModelContentChanges = false;
      highlighterDisposer && highlighterDisposer.dispose();
      highlighterDisposer = null;
    };
    monacoEditor.onDidDispose(function () {
      _this.decoratorMapper.reset();
      highlighterDisposer = null;
      _isHighlightBoundToModelContentChanges = false;
    });
    return onDispose;
  };
  this.highLightOnDidChangeModelContent = this.highlightOnDidChangeModelContent;
});

export { BabelDataExtractor, HIGHLIGHT_MODE, HIGHLIGHT_TYPE, JSXCommentContexts, JSXTypes, MonacoEditorManager, collectJSXExpressions, configureLoc2Range, configureRange2Loc, MonacoJSXHighlighter as default, getJSXContext, makeGetAstPromise, makeJSXCommenterBundle, makeParseJSXExpressionsPromise, prepareOptions };
//# sourceMappingURL=monaco-jsx-highlighter.js.map
